import grok
from grok import index
from zope.component import getUtility
from zope.interface import Interface

from waeup.interfaces import (IUniversity, IStudentContainer, IHostelContainer,
                              IFacultyContainer)
from waeup.viewlets import MainArea

class University(grok.Application, grok.Container):
    """A university.
    """
    grok.implements(IUniversity)

    def __init__(self, name=u'Unnamed', **kw):
        super(University, self).__init__(**kw)
        self.name = name
        self.setup()

    def setup(self):
        self["students"] = getUtility(IStudentContainer)
        self["hostels"] = getUtility(IHostelContainer)
        self["faculties"] = getUtility(IFacultyContainer)
        
class Manage(grok.EditForm):
    """Manage the basic properties of a `University` instance.
    """

    grok.require('waeup.ManageUniversity')
    
    form_fields = grok.AutoFields(IUniversity)

    @grok.action('Save')
    def save(self, **data):
        self.applyData(self.context, **data)
        return
    
    @grok.action('Save and return')
    def saveAndReturn(self, **data):
        self.applyData(self.context, **data)
        self.redirect(self.url(self.context))
        return

    @grok.action('Cancel')
    def cancel(self):
        self.redirect(self.url(self.context))
        return
        
class Content(grok.Viewlet):
    grok.viewletmanager(MainArea)
    grok.context(IUniversity)


class Edit(grok.EditForm):
    grok.context(University)
    grok.AutoFields(IUniversity)
